package dev.fitko.fitconnect.core.http;

import dev.fitko.fitconnect.api.config.BuildInfo;
import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;
import org.jetbrains.annotations.NotNull;

import java.io.IOException;

import static dev.fitko.fitconnect.core.http.HttpHeaders.USER_AGENT;

public class UserAgentInterceptor implements Interceptor {

    private final String productName;
    private final String productVersion;
    private final String commit;

    public UserAgentInterceptor(BuildInfo buildInfo) {
        this.productName = buildInfo.getProductName();
        this.productVersion = buildInfo.getProductVersion();
        this.commit = buildInfo.getCommit();
    }

    @NotNull
    @Override
    public Response intercept(@NotNull Chain chain) throws IOException {

        Request request = chain.request().newBuilder().header(USER_AGENT,String.format("%s/%s (commit:%s;os:%s)",
                this.productName, this.productVersion, this.commit, System.getProperty("os.name"))).build();

        return chain.proceed(request);
    }
}
